diff -Naur WebKit-r41128/WebKit/gtk/webkit/webkitwebview.cpp WebKit-r41128-nx/WebKit/gtk/webkit/webkitwebview.cpp
--- WebKit-r41128/WebKit/gtk/webkit/webkitwebview.cpp	2009-02-15 03:48:54.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/webkit/webkitwebview.cpp	2009-02-25 19:01:33.377006750 -0500
@@ -25,6 +25,7 @@
 
 #include "config.h"
 
+#include "webkitwebdownload.h"
 #include "webkitwebview.h"
 #include "webkitenumtypes.h"
 #include "webkitmarshal.h"
@@ -49,6 +50,7 @@
 #include "EventHandler.h"
 #include "FloatQuad.h"
 #include "FocusController.h"
+#include "FloatQuad.h"
 #include "FrameLoaderTypes.h"
 #include "HitTestRequest.h"
 #include "HitTestResult.h"
@@ -111,6 +113,7 @@
     NAVIGATION_REQUESTED,
     NAVIGATION_POLICY_DECISION_REQUESTED,
     MIME_TYPE_POLICY_DECISION_REQUESTED,
+    REQUEST_POLICY_DECISION_REQUESTED,
     CREATE_WEB_VIEW,
     WEB_VIEW_READY,
     WINDOW_OBJECT_CLEARED,
@@ -132,6 +135,7 @@
     COPY_CLIPBOARD,
     PASTE_CLIPBOARD,
     CUT_CLIPBOARD,
+    DOWNLOAD_CREATED,
     LAST_SIGNAL
 };
 
@@ -234,14 +238,14 @@
         start.getInlineBoxAndOffset(DOWNSTREAM, startInlineBox, startCaretOffset);
         IntRect startCaretRect = renderer->localCaretRect(startInlineBox, startCaretOffset, &extraWidthToEndOfLine);
         if (startCaretRect != IntRect())
-            startCaretRect = renderer->localToAbsoluteQuad(FloatRect(startCaretRect)).enclosingBoundingBox();
+            startCaretRect = renderer->localToAbsoluteQuad(FloatQuad(startCaretRect)).enclosingBoundingBox();
 
         InlineBox* endInlineBox;
         int endCaretOffset;
         end.getInlineBoxAndOffset(UPSTREAM, endInlineBox, endCaretOffset);
         IntRect endCaretRect = renderer->localCaretRect(endInlineBox, endCaretOffset);
         if (endCaretRect != IntRect())
-            endCaretRect = renderer->localToAbsoluteQuad(FloatRect(endCaretRect)).enclosingBoundingBox();
+            endCaretRect = renderer->localToAbsoluteQuad(FloatQuad(endCaretRect)).enclosingBoundingBox();
 
         IntRect firstRect;
         if (startCaretRect.y() == endCaretRect.y())
@@ -490,6 +494,8 @@
     if (focusedFrame && focusedFrame->editor()->canEdit()) {
 #ifdef MAEMO_CHANGES
         WebKitWebViewPrivate* priv = webView->priv;
+	if (focusedFrame->document()->useSecureKeyboardEntryWhenActive())
+	    g_object_set(G_OBJECT(priv->imContext), "hildon_input_mode", 0x20000000);
         hildon_gtk_im_context_filter_event(priv->imContext, (GdkEvent*)event);
 #endif
     }
@@ -810,6 +816,13 @@
     frame->editor()->command("Paste").execute();
 }
 
+static gboolean webkit_web_view_real_download_created(WebKitWebView* web_view, WebKitWebDownload* download)
+{
+    webkit_web_download_cancel(download);  
+    // Return false to indicate it wasn't handled therefore the download is deleted
+    return FALSE;
+}
+
 static void webkit_web_view_dispose(GObject* object)
 {
     WebKitWebView* webView = WEBKIT_WEB_VIEW(object);
@@ -1056,6 +1069,18 @@
             G_TYPE_STRING,
             WEBKIT_TYPE_WEB_POLICY_DECISION);
 
+    webkit_web_view_signals[REQUEST_POLICY_DECISION_REQUESTED] = g_signal_new("request-policy-decision-requested",
+            G_TYPE_FROM_CLASS(webViewClass),
+            (GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
+            0,
+            g_signal_accumulator_true_handled,
+            NULL,
+            webkit_marshal_BOOLEAN__OBJECT_OBJECT_STRING,
+            G_TYPE_BOOLEAN, 3,
+            WEBKIT_TYPE_WEB_FRAME,
+            G_TYPE_STRING,
+            WEBKIT_TYPE_NETWORK_REQUEST);
+
     /**
      * WebKitWebView::window-object-cleared:
      * @web_view: the object on which the signal is emitted
@@ -1083,6 +1108,24 @@
             G_TYPE_POINTER,
             G_TYPE_POINTER);
 
+     /**
+     * WebKitWebView::download-created:
+     * @web_view: the object on which the signal is emitted
+     * @download: the message text
+     * @return: TRUE if the download was handled, otherwise it'll be cancelled.
+     *
+     * A new Download has been created
+     */
+    webkit_web_view_signals[DOWNLOAD_CREATED] = g_signal_new("download-created",
+            G_TYPE_FROM_CLASS(webViewClass),
+            (GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
+            G_STRUCT_OFFSET(WebKitWebViewClass, download_created),
+            g_signal_accumulator_true_handled,
+            NULL,
+            webkit_marshal_BOOLEAN__OBJECT,
+            G_TYPE_BOOLEAN, 1,
+            G_TYPE_OBJECT);
+
     /**
      * WebKitWebView::load-started:
      * @web_view: the object on which the signal is emitted
@@ -1392,6 +1435,7 @@
     webViewClass->cut_clipboard = webkit_web_view_real_cut_clipboard;
     webViewClass->copy_clipboard = webkit_web_view_real_copy_clipboard;
     webViewClass->paste_clipboard = webkit_web_view_real_paste_clipboard;
+    webViewClass->download_created = webkit_web_view_real_download_created;
 
     GObjectClass* objectClass = G_OBJECT_CLASS(webViewClass);
     objectClass->dispose = webkit_web_view_dispose;
@@ -1870,6 +1914,33 @@
 }
 
 /**
+ * webkit_web_view_inspect:
+ * @web_view: a #WebKitWebView
+ *
+ * Activates the #WebKitWebInspector associated with the
+ * #WebKitWebView. The inspector is started with the document
+ * node of the currently focused frame, or the main frame of
+ * the #WebKitWebView.
+ *
+ * Since: 1.0.3
+ */
+void webkit_web_view_inspect(WebKitWebView* webView)
+{
+    g_return_if_fail(WEBKIT_IS_WEB_VIEW(webView));
+
+    Frame* frame = core(webView)->focusController()->focusedOrMainFrame();
+
+    core(webView)->inspectorController()->inspect(frame->document());
+}
+
+void webkit_web_view_menu_popup(WebKitWebView* webView)
+{
+    g_return_if_fail(WEBKIT_IS_WEB_VIEW(webView));
+
+    webkit_web_view_popup_menu_handler(GTK_WIDGET(webView));
+}
+
+/**
  * webkit_web_view_get_window_features
  * @web_view: a #WebKitWebView
  *
diff -Naur WebKit-r41128/WebKit/gtk/webkit/webkitwebview.h WebKit-r41128-nx/WebKit/gtk/webkit/webkitwebview.h
--- WebKit-r41128/WebKit/gtk/webkit/webkitwebview.h	2009-02-15 03:48:54.000000000 -0500
+++ WebKit-r41128-nx/WebKit/gtk/webkit/webkitwebview.h	2009-02-25 18:52:48.232005950 -0500
@@ -102,6 +102,8 @@
     void                       (* cut_clipboard)          (WebKitWebView        *web_view);
     void                       (* copy_clipboard)         (WebKitWebView        *web_view);
     void                       (* paste_clipboard)        (WebKitWebView        *web_view);
+    gboolean                   (* download_created)       (WebKitWebView        *web_view,
+                                                           WebKitWebDownload    *download);
 
     /*
      * internal
@@ -270,6 +272,9 @@
 WEBKIT_API WebKitWebInspector *
 webkit_web_view_get_inspector                   (WebKitWebView        *web_view);
 
+WEBKIT_API void
+webkit_web_view_inspect                         (WebKitWebView        *web_view);
+
 WEBKIT_API WebKitWebWindowFeatures*
 webkit_web_view_get_window_features             (WebKitWebView        *web_view);
 
@@ -304,6 +309,9 @@
 webkit_web_view_set_full_content_zoom           (WebKitWebView        *web_view,
                                                  gboolean              full_content_zoom);
 
+WEBKIT_API void 
+webkit_web_view_menu_popup						(WebKitWebView        *web_view);
+
 G_END_DECLS
 
 #endif
diff -Naur WebKit-r41128/WebKitTools/DumpRenderTree/gtk/DumpRenderTree.cpp WebKit-r41128-nx/WebKitTools/DumpRenderTree/gtk/DumpRenderTree.cpp
--- WebKit-r41128/WebKitTools/DumpRenderTree/gtk/DumpRenderTree.cpp	2009-01-21 00:14:31.000000000 -0500
+++ WebKit-r41128-nx/WebKitTools/DumpRenderTree/gtk/DumpRenderTree.cpp	2009-02-23 16:01:27.615503310 -0500
@@ -348,7 +348,7 @@
 
 int main(int argc, char* argv[])
 {
-    g_thread_init(NULL);
+//    g_thread_init(NULL);
     gtk_init(&argc, &argv);
 
     struct option options[] = {
diff -Naur WebKit-r41128/WebKitTools/DumpRenderTree/LayoutTestController.cpp WebKit-r41128-nx/WebKitTools/DumpRenderTree/LayoutTestController.cpp
--- WebKit-r41128/WebKitTools/DumpRenderTree/LayoutTestController.cpp	2009-02-15 03:48:56.000000000 -0500
+++ WebKit-r41128-nx/WebKitTools/DumpRenderTree/LayoutTestController.cpp	2009-02-23 16:01:27.632007390 -0500
@@ -734,7 +734,7 @@
         return JSValueMakeUndefined(context);
 
     LayoutTestController* controller = reinterpret_cast<LayoutTestController*>(JSObjectGetPrivate(thisObject));
-    return JSValueMakeNumber(context, controller->numberOfActiveAnimations());
+    return JSValueMakeUndefined(context);//JSValueMakeNumber(context, controller->numberOfActiveAnimations());
 }
 
 // Static Values
diff -Naur WebKit-r41128/WebKitTools/GtkLauncher/main.c WebKit-r41128-nx/WebKitTools/GtkLauncher/main.c
--- WebKit-r41128/WebKitTools/GtkLauncher/main.c	2009-01-27 02:55:35.000000000 -0500
+++ WebKit-r41128-nx/WebKitTools/GtkLauncher/main.c	2009-02-23 16:01:27.656007070 -0500
@@ -1,6 +1,7 @@
 /*
  * Copyright (C) 2006, 2007 Apple Inc.
  * Copyright (C) 2007 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Collabora, Ltd.  All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -106,6 +107,107 @@
     webkit_web_view_go_forward (web_view);
 }
 
+static gboolean
+download_error_cb (WebKitWebDownload* download, guint domain, WebKitWebDownloadError error, const gchar * message, gpointer data)
+{
+    g_warning("Download Error: %s\n", message);
+    return TRUE;
+}
+
+static void
+download_finished_cb (WebKitWebDownload* download, gpointer data)
+{
+    gtk_button_set_label(GTK_BUTTON(data), GTK_STOCK_CLOSE);
+}
+
+static void
+download_progress_cb (WebKitWebDownload* download, guint current_bytes, guint total_bytes, gpointer progress_bar)
+{
+    if(GTK_IS_PROGRESS_BAR(progress_bar))
+    {
+        gdouble progress = (double)current_bytes/total_bytes;
+        gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progress_bar), progress);
+    }
+}
+
+static void
+download_button_cb (GtkButton* button, WebKitWebDownload* download)
+{
+    if (webkit_web_download_get_state(download) == WEBKIT_WEB_DOWNLOAD_STATE_FINISHED ||
+        webkit_web_download_get_state(download) == WEBKIT_WEB_DOWNLOAD_STATE_ERROR) {
+        GdkWindow* window = gtk_widget_get_parent_window(GTK_WIDGET(button));
+        gdk_window_hide(window);
+        g_object_unref(download);
+    } else 
+        webkit_web_download_cancel(download);
+}
+
+static void
+save_dialog_response_cb (GtkFileChooser *file_chooser, gint response, WebKitWebDownload* download)
+{
+    if (response == GTK_RESPONSE_OK) {
+        webkit_web_download_set_local_uri(download, gtk_file_chooser_get_uri (GTK_FILE_CHOOSER (file_chooser)));
+    } /*else {
+        gtk_widget_destroy (window);
+        handled = FALSE;
+    }*/
+
+    gtk_widget_destroy (file_chooser);
+}
+      
+static gboolean
+download_created_cb (WebKitWebView* view, WebKitWebDownload* download, gpointer data)
+{
+    gboolean handled = TRUE;
+    GtkWidget* window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
+    gtk_window_set_title(GTK_WINDOW(window), "Download");
+    
+    GtkWidget* vbox = gtk_vbox_new(TRUE, 0);
+    gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
+    
+    GtkWidget* uri_label = gtk_label_new(NULL);
+    gtk_label_set_single_line_mode(GTK_LABEL(uri_label), FALSE);
+    gtk_label_set_markup(GTK_LABEL(uri_label), 
+        g_strconcat("<b>URI:</b> ", 
+            webkit_web_download_get_uri(download), 
+            "\n<b>Filename:</b> ",
+            webkit_web_download_get_suggested_filename(download),
+            NULL)
+        );
+    gtk_label_set_justify(GTK_LABEL(uri_label), GTK_JUSTIFY_LEFT);
+    gtk_box_pack_start(GTK_BOX(vbox), uri_label, FALSE, FALSE, 0);
+
+    GtkWidget* progress_bar = gtk_progress_bar_new();         
+    gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(progress_bar), GTK_PROGRESS_LEFT_TO_RIGHT);
+    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progress_bar), 0.0); 
+    gtk_box_pack_start(GTK_BOX(vbox), progress_bar, FALSE, FALSE, 0);
+
+    GtkWidget* button_box = gtk_hbutton_box_new();
+    gtk_button_box_set_layout(GTK_BUTTON_BOX(button_box), GTK_BUTTONBOX_END);
+    GtkWidget* button = gtk_button_new_from_stock(GTK_STOCK_CANCEL);
+    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (download_button_cb), download);
+    gtk_box_pack_start(GTK_BOX(button_box), button, FALSE, FALSE, 0);
+    gtk_box_pack_start(GTK_BOX(vbox), button_box, FALSE, FALSE, 0);
+    
+    gtk_container_add(GTK_CONTAINER(window), vbox);
+    
+    gtk_widget_show_all(GTK_WIDGET(window));
+    
+    GtkWidget* file_chooser = gtk_file_chooser_dialog_new("Select destination...", GTK_WINDOW(window), GTK_FILE_CHOOSER_ACTION_SAVE, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE, GTK_RESPONSE_OK, NULL);
+    gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (file_chooser), webkit_web_download_get_suggested_filename (download));
+    g_signal_connect (G_OBJECT (file_chooser), "response", G_CALLBACK (save_dialog_response_cb), download);
+    gtk_widget_show (file_chooser);
+
+    g_signal_connect (G_OBJECT (download), "finished", G_CALLBACK (download_finished_cb), button);
+    g_signal_connect (G_OBJECT (download), "progress-update", G_CALLBACK (download_progress_cb), progress_bar);
+    g_signal_connect (G_OBJECT (download), "error", G_CALLBACK (download_error_cb), window);
+
+    if (handled)
+        g_object_ref(download);
+
+    return handled;
+}
+
 static GtkWidget*
 create_browser ()
 {
@@ -119,6 +221,7 @@
     g_signal_connect (G_OBJECT (web_view), "load-progress-changed", G_CALLBACK (progress_change_cb), web_view);
     g_signal_connect (G_OBJECT (web_view), "load-committed", G_CALLBACK (load_commit_cb), web_view);
     g_signal_connect (G_OBJECT (web_view), "hovering-over-link", G_CALLBACK (link_hover_cb), web_view);
+    g_signal_connect (G_OBJECT (web_view), "download-created", G_CALLBACK (download_created_cb), web_view);
 
     return scrolled_window;
 }
@@ -183,8 +286,8 @@
 main (int argc, char* argv[])
 {
     gtk_init (&argc, &argv);
-    if (!g_thread_supported ())
-        g_thread_init (NULL);
+/*    if (!g_thread_supported ())
+        g_thread_init (NULL);*/
 
     GtkWidget* vbox = gtk_vbox_new (FALSE, 0);
     gtk_box_pack_start (GTK_BOX (vbox), create_toolbar (), FALSE, FALSE, 0);
